%define name		joram
%define version		4.1.5
%define release		%mkrel 1.1
%define	section		free
%define gcj_support	1


Name:		%{name}
Summary:	JORAM: Java (TM) Open Reliable Asynchronous Messaging
Url:		http://joram.objectweb.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	LGPL
Group:		Development/Java
Source0:	joram-%{version}-src-RHCLEAN.tar.bz2
Patch0:		joram-monolog-Debug.patch.bz2
Patch1:		joram-mx4j.patch.bz2
Patch2:		joram-javadoc.patch.bz2
Patch3:		joram-adaptor.patch.bz2

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	ant >= 0:1.6
BuildRequires:	j2ee-connector >= 0:1.5
BuildRequires:	jaf
BuildRequires:	java >= 0:1.4
BuildRequires:	java_cup
BuildRequires:	javamail
BuildRequires:	jms
BuildRequires:	mx4j
BuildRequires:	jta
# FIXME: We do not ship oldkxml (we rather wait for JORAM to move to kxml)
#BuildRequires:	oldkxml
BuildRequires:	monolog >= 0:1.8
BuildRequires:	regexp
# FIXME This is the old abandoned Apache SOAP project
# JORAM should be using AXIS instead
#BuildRequires:	soap
BuildRequires:	xerces-j2
Requires:	j2ee-connector >= 0:1.5
Requires:	jaf
Requires:	java >= 0:1.4
Requires:	java_cup
Requires:	javamail
Requires:	jms
Requires:	jmxri
Requires:	jta
# FIXME: We do not ship oldkxml (we rather wait for JORAM to move to kxml)
#Requires:	oldkxml
Requires:	monolog >= 0:1.8
Requires:	regexp
# FIXME This is the old abandoned Apache SOAP project
# JORAM should be using AXIS instead
#Requires:	soap
Requires:	xerces-j2
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
# libgcj aot-compiled native libraries
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel >= 0:1.0.31
Requires(post):   java-gcj-compat >= 0:1.0.31
Requires(postun): java-gcj-compat >= 0:1.0.31
%endif

%description
JORAM incorporates a 100% pure Java implementation of JMS
(Java Message Service API released by Sun Microsystem, Inc.). 
It provides access to a MOM (Message Oriented Middleware), 
built on top of the ScalAgent agents based distributed 
platform.


%package for-jonas
Summary:	A JORAM JCA adapter for JOnAS
Group:		Development/Java
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description for-jonas
A JORAM JCA 1.5 adapter for JOnAS 4.5.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Java

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}
chmod -R go=u-w *
%patch0 -b .sav
%patch1 -p1
%patch2 -p1
%patch3 -p1

# clean jarfiles
find . -name "*.jar" -exec rm -f {} \;
find . -name "*.war" -exec rm -f {} \;

# remove classes that don't build without said jarfiles
rm -f src/fr/dyade/aaa/jndi2/soap/SoapExt_*.java
rm -f src/org/objectweb/joram/client/jms/soap/*.java
rm -f src/org/objectweb/joram/client/jms/admin/ObjectFactory.java

%build
pushd lib
ln -sf $(build-classpath j2ee-connector) .
ln -sf $(build-classpath jaf) .
ln -sf $(build-classpath java_cup) .
ln -sf $(build-classpath java_cup-runtime) .
ln -sf $(build-classpath javamail/mailapi) .
ln -sf $(build-classpath jms) .
ln -sf $(build-classpath mx4j/mx4j-jmx) .
ln -sf $(build-classpath mx4j/mx4j-tools) .
ln -sf $(build-classpath jndi) .
ln -sf $(build-classpath jta) .
# FIXME: We do not ship oldkxml (we rather wait for JORAM to move to kxml)
#ln -sf $(build-classpath oldkxml) .
ln -sf $(build-classpath monolog/ow_monolog) .
ln -sf $(build-classpath regexp) .
# FIXME This is the old abandoned Apache SOAP project
# JORAM should be using AXIS instead
#ln -sf $(build-classpath soap) .
ln -sf $(build-classpath xerces-j2) .
popd

%ant -f src/joram.xml build.joram build.jonasadapter javadoc

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 build/%{name}-shared.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/shared-%{version}.jar
install -m 644 build/%{name}-mom.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/mom-%{version}.jar
install -m 644 build/%{name}-client.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/client-%{version}.jar
install -m 644 build/%{name}-connector.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/connector-%{version}.jar
install -m 644 build/%{name}-gui.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/gui-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# rars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/rars

install -m 644 build/%{name}_for_jonas_ra.rar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/rars/%{name}_for_jonas_ra-%{version}.rar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/rars && for rar in *-%{version}*; do ln -sf ${rar} `echo $rar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_jvmdir}/java-gcj/bin/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post
%{_bindir}/rebuild-gcj-db

%postun
%{_bindir}/rebuild-gcj-db
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root)
%doc licenses/LGPL_HEADER.TXT
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}
%endif

%files for-jonas
%defattr(-,root,root)
%dir %{_javadir}/%{name}/rars
%{_javadir}/%{name}/rars/joram_for_jonas_ra*.rar

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Sat Sep 10 2005 David Walluck <walluck@mandriva.org> 0:4.1.5-1.1mdk
- release

* Mon Aug  8 2005 Gary Benson <gbenson@redhat.com> 0:4.1.5-1jpp_5fc
- Add jonas resource adaptor.

* Tue Aug  2 2005 Gary Benson <gbenson@redhat.com> 0:4.1.5-1jpp_4fc
- Build on ia64, ppc64, s390 and s390x.
- Switch to aot-compile-rpm.

* Tue Jun 28 2005 Gary Benson <gbenson@redhat.com> 0:4.1.5-1jpp_3fc
- BC-compile.

* Wed Jun 22 2005 Gary Benson <gbenson@redhat.com> 0:4.1.5-1jpp_2fc
- Remove warfile from the tarball too.

* Thu Jun 16 2005 Gary Benson <gbenson@redhat.com> 0:4.1.5-1jpp_1fc
- Build into Fedora.

* Thu Jun  9 2005 Gary Benson <gbenson@redhat.com>
- Remove jarfiles from the tarball.
- Remove classes that don't build without said jarfiles.

* Mon Jun  6 2005 Gary Benson <gbenson@redhat.com>
- Replace build-time jmx references with mx4j ones.
- Fix broken javadoc generation.

* Fri Mar 04 2005 Fernando Nasser <fnasser@redhat.com> 0:4.1.5-1jpp_1rh
- First Red Hat build
- Temporarely keep the kxml 1.x jar (JORAM will move to use another thing)
- Temporarely keep the old Apache soap 1.x jar (request JORAM community to move to AXIS)

* Mon Feb 28 2005 Fernando Nasser <fnasser@redhat.com> 0:4.1.5-1jpp
- Upgrade to 4.1.5

* Mon Oct 04 2004 Ralph Apel <r.apel at r-apel.de> 0:4.1.0-1jpp
- First release

